format ELF64

section '.data' writeable
inum    db      'Please, enter an integer number from 1 to 20? ', 00h
oerr    db      'Error: Number out of range!', 00h
ofact   db      'The factorial of this number is %llu', 00h
formatn db      '%u', 00h
formats db      '%s', 00h
num     dq      0

section '.text' executable
public main
extrn printf
extrn scanf
main:
        mov     rbp, rsp
        sub     rsp, 32
        and     rsp, -16
        mov     rcx, formats
        mov     rdx, inum
        call    printf
        mov     rcx, formatn
        mov     rdx, num        
        call    scanf
        mov     rax, [num]
        cmp     rax, 1
        jl      invalid
        cmp     rax, 20
        jg      invalid
        mov     rbx, rax
next:
        dec     rbx
        cmp     rbx, 0
        je      done    
        mul     rbx
        jmp     next
done:
        mov     rcx, ofact
        mov     rdx, rax
        jmp     exit
invalid:
        mov     rcx, formats
        mov     rdx, oerr        
exit:
        call    printf
        mov     rsp, rbp
        xor     rax, rax
        ret
